tyvj2030 题解

给出两个由数字和字母组成的非空字符串S,T,求:

1)S与T的最长公共子序列的长度。

2)S与T的本质不同的非空公共子序列的个数。

3)S与T的各种长度的本质不同的非空公共子序列的个数。

思考过程:考场上,果断只会第一问,但是听完题解后,发现事实上他们的思想和第一问是一致的。(此题解借鉴讲题解人)

首先考虑第二问,设dp(i,j)表示s串的前i位和t串的前j位,分两种情况讨论

若s[i]=s[j],则直接把这个字符接在后面,有接和不接两种则dp(i,j)=dp(i-1,j-1)*2,但是我们需要将此结果减去dp(u-1,v-1)其中uv是ij最近相同字符, 考虑dp[u-1][v-1]对应集合中的串x,记S[i]=c,则x,xc∈dp[u][v],则x,xc∈dp[i-1][j-1]。串xc就会在dp[i][j]的集合中出现两遍。

若是s[i]!=s[j],则dp(i,j)=dp(i,j-1)+dp(i-1,j)-dp(i-1,j-1)

这样就解决了第二问,而第三问就是在第二问上加一维,k为长度,dp方程则是一模一样。

 1 #include<iostream>
 2 #include<cstdio>
 3 #include<cstring>
 4 #include<cstdlib>
 5 using namespace std;
 6 string a,b;
 7 int f[305][305];
 8 int g[305][305][305];
 9 int prea[305],preb[305];
10 int ans;
11 const int MOD=1048576;
12 const int SIE = 0xFFFFF;
13 int n,m;
14 int ss;
15 int main()
16 {
17 //    freopen("common5.in","r",stdin);
18 //    freopen("common5.out","w",stdout);
19     cin>>a;cin>>b;
20     n=a.size();
21     m=b.size();
22     a=‘0‘+a;
23     b=‘0‘+b;
24     for(int i=1;i<=n;i++)
25     {
26         for(int j=1;j<=m;j++)
27         {
28             if(a[i]==b[j])f[i][j]=f[i-1][j-1]+1;
29             f[i][j]=max(f[i][j],f[i-1][j]);
30             f[i][j]=max(f[i][j],f[i][j-1]);
31         }
32     }
33     printf("%d\n",f[n][m]);
34     ss=f[n][m];
35     for(int i=1;i<=n;i++)
36     {
37         int j=i-1;
38         while(j>0 && a[j]!=a[i])j--;
39         prea[i]=j;
40     //    cout<<j;
41     }
42     for(int i=1;i<=m;i++)
43     {
44         int j=i-1;
45         while(j>0 && b[j]!=b[i])j--;
46         preb[i]=j;
47         //cout<<j;
48     }
49     for(int i=0;i<=n;i++)
50     {
51         for(int j=0;j<=m;j++)
52         {
53             g[i][j][0]=1;
54         }
55     }
56     for(int i=1;i<=n;i++)
57     {
58         for(int j=1;j<=m;j++)
59         {
60             if(a[i]==b[j])
61             {
62                 for(int k=1;k<=ss;k++)
63                 {
64                     g[i][j][k]=(g[i-1][j-1][k]+g[i-1][j-1][k-1])&SIE;
65                 }
66                 if(prea[i] && preb[j])
67                 {
68                     for(int k=1;k<=ss;k++)
69                     {
70                         g[i][j][k]=(g[i][j][k]-g[prea[i]-1][preb[j]-1][k-1])&SIE;
71                     }
72                 }
73             }
74             else
75             {
76                 for(int k=1;k<=ss;k++)
77                 {
78                     g[i][j][k]=(g[i-1][j][k]+g[i][j-1][k]-g[i-1][j-1][k])&SIE;
79                     //cout<<i<<" "<<j<<" "<<k<<" "<<g[i][j][k]<<endl;
80                 }
81             }
82         }
83     }
84     int sum=0;
85     for(int i=1;i<=ss;i++)sum=(sum+g[n][m][i])%MOD;
86     printf("%d\n",sum);
87     for(int i=1;i<=ss;i++)printf("%d\n",g[n][m][i]);
88     return 0;
89 }

tyvj2030 题解,布布扣,bubuko.com

时间: 2024-12-19 00:04:51

tyvj2030 题解的相关文章

洛谷 P1079 Vigen&#232;re 密码 题解

此文为博主原创题解,转载时请通知博主,并把原文链接放在正文醒目位置. 题目链接:https://www.luogu.org/problem/show?pid=1079 题目描述 16 世纪法国外交家 Blaise de Vigenère 设计了一种多表密码加密算法――Vigenère 密 码.Vigenère 密码的加密解密算法简单易用,且破译难度比较高,曾在美国南北战争中为 南军所广泛使用. 在密码学中,我们称需要加密的信息为明文,用 M 表示:称加密后的信息为密文,用 C 表示:而密钥是一种

8.8联考题解

今天的T1让我怀疑我是不是在做奥赛题--这考的是什么知识点啊这个,会不会用绝对值函数? Evensgn 的债务 时间限制: 1 Sec  内存限制: 128 MB 题目描述 Evensgn 有一群好朋友,他们经常互相借钱.假如说有三个好朋友A,B,C.A 欠 B 20 元,B 欠 C 20 元,总债务规模为 20+20=40 元.Evensgn 是个追求简约的人,他觉得这样的债务太繁杂了.他认为,上面的债务可以完全等价为 A 欠C20 元,B 既不欠别人,别人也不欠他.这样总债务规模就压缩到了 

POJ 2533 - Longest Ordered Subsequence(最长上升子序列) 题解

此文为博主原创题解,转载时请通知博主,并把原文链接放在正文醒目位置. 题目链接:http://poj.org/problem?id=2533 Description A numeric sequence of ai is ordered if a1 < a2 < ... < aN. Let the subsequence of the given numeric sequence (a1, a2, ..., aN) be any sequence (ai1, ai2, ..., aiK)

(leetcode题解)Pascal&#39;s Triangle

Pascal's Triangle  Given numRows, generate the first numRows of Pascal's triangle. For example, given numRows = 5,Return [ [1], [1,1], [1,2,1], [1,3,3,1], [1,4,6,4,1] ] 题意实现一个杨辉三角. 这道题只要注意了边界条件应该很好实现出来,C++实现如下 vector<vector<int>> generate(int

2017ZZUACM省赛选拔试题部分题解----谨以纪念我这卡线滚粗的美好经历

写在前面: 其实心里有些小小的不爽又有点小小的舒畅,为啥捏?不爽当然是因为没被选拔上啦,舒畅捏则是因为没被选拔上反而让自己警醒,学长也提点很多很多."沉下去,然后一战成名"学长如是对我说,我很开心.其实这完全算不算是题解,只是我个人的一些小想法而已.而且到现在还有一题不会...让自己长点记性吧. 题目 A :聪明的田鼠 Time Limit: 1 Sec Memory Limit: 128 MB Description 田鼠MIUMIU来到了一片农田,农田可以看成是一个M*N个方格的矩

LeetCode-001题解

此题目摘自LeetCode001 Given an array of integers, find two numbers such that they add up to a specific target number. The function twoSum should return indices of the two numbers such that they add up to the target, where index1 must be less than index2.

leetcode题解: Next Permutation

最近还一直在刷leetcode,当然,更多时候只是将题解写在自己的电脑上,没有分享出来.偶尔想起来的时候,就写出来. public class Solution { public void nextPermutation(int[] nums) { if(nums==null||nums.length<=1) return; nextPermutationHelp( nums,0,nums.length-1); } public void nextPermutationHelp(int []nu

HDU 5014 Number Sequence(2014 ACM/ICPC Asia Regional Xi&#39;an Online) 题解

题目链接:http://acm.hdu.edu.cn/showproblem.php?pid=5014 Number Sequence Problem Description There is a special number sequence which has n+1 integers. For each number in sequence, we have two rules: ● ai ∈ [0,n] ● ai ≠ aj( i ≠ j ) For sequence a and sequ

HDU 1045 Fire Net 二分图Bipartite题解

本题可以使用DFS直接爆搜出答案,不过这样类型的题目其实是个二分图的题解. 这个二分图,难不在Hungary算法,而是难在于建图.需要挺高的抽象思维的. 建图: 1 把同一行不被X分开的格子标同一个号码,被X分开的标下一个号码,这样做是为了缩点,不需要把所有的格子都分开标号,而且可以更方便建个更加小的图. 2 同理把同一列的格子标号 3 然后判断相同一个格子的行标号和列标号是有路径的,其他不在同一个格子的都是没有路径的. 4 这样就等于以行标号和列标号作为左右顶点,构建成一个二分图了 然后使用H